CON
{''Hardware version 2.11 - see diagram.
''
}                                 
  DEV_SPI_EN        = 21                               ''SPI Enable enumeration
  DEV_SPI_ADD0      = 22                               ''Device address 0 enumeration
  DEV_SPI_ADD1      = 23                               ''Device address 1 enumeration
  DEV_SPI_LCD_RES   = 0                 ''Device id for LCD reset
  
 _clkmode       = xtal1 + pll16x                        ' use crystal x 16
 _xinfreq       = 5_000_000                             'with 5mhz crystal

  BGCOLOR                       = $ffff
  TXTCOLOR                      = $0000
   Pressed                       = 1

   
  NotPressed                    = 0
VAR
 long Screen_Buffer, CRbuffer
   long BackgroundColor, ActiveTextColor, stringptr[65]

   BYTE Fader0[3], Fader1[3], Fader2[3], Fader3[3], faderOrentation, faderpos, faderval, oldfader 'Fader POS, New Fader Value, Old Fader Value, FaderOrentation holds 0 for landscape, portrait not enabled 
OBJ pfw :"PropFont_asmDone"
     'wait : "timing"
     button : "Button"
     fader : "fader"
           
PUB BOOT   | f                       'bootstrap, initalizes pins, then starts pst, init display, start asm, clear screen and display hello world
  dirA[DEV_SPI_ADD0]   := 1             'makes address 0 and 1          
  dirA[DEV_SPI_ADD1]   := 1             'outputs
  dirA[DEV_SPI_EN]     := 1
 'and enable an output as well
OUTA[DEV_SPI_ADD1..DEV_SPI_ADD0] := 3 
  'OUTA[LCD_WR]         := 0            'prime WR pin
  'OUTA[LCD_RS]         := 0            'and RS pin, probably not needed.
  OUTA[DEV_SPI_EN]     := 1             'Disable - Reset Screen
    'wait.pause1s(5)                                 
   ''PST_Init                          'Start Parallax Serial Terminal
BackgroundColor := $ffe0
ActiveTextColor := %0000  
 long[@Screen_Buffer]          := $ffff                        'make sure screen buffer does not equal 0  
   pfw.Start(@Long[@Screen_Buffer])                         'Start Asm Driver, needs to be changed to pass screen buffer from top object
   '' pst.newline                                  
   ''pst.str(string("Starting Asm"))             'Talk to human
   ''pst.newline
   dirA[DEV_SPI_EN]     := 1   
    OUTA[DEV_SPI_EN]     := 1             'Disable - Reset Screen 
   pfw.ClearScreen(BackgroundColor)            'Draw White Screen with asm
   helloworld                       'draw hello world
  {Fader.}FaderTest
  '{Button.}ButtonTest
  FaderRun
  deadend                            'hold cog in endless loop
PUB HelloWorld
    pfw.WriteActiveCr("H", 0, 0*16, 0, 0, BackgroundColor, ActiveTextColor)    
    pfw.WriteNextActiveCr("e")
    pfw.WriteNextActiveCr("l")
    pfw.WriteNextActiveCr("l")
    pfw.WriteNextActiveCr("o")
    pfw.WriteNextActiveCr(" ")
    pfw.WriteNextActiveCr("W")
    pfw.WriteNextActiveCr("o")
    pfw.WriteNextActiveCr("r")
    pfw.WriteNextActiveCr("l")
    pfw.WriteNextActiveCr("d")
pub deadend                                                               'loop for testing
  repeat                                                                             'endlessly wait
    repeat
     waitcnt(2_000 + cnt)

PUB FaderTest | F , b
Fader0[0] :=255
Fader0[1] := 0
Fader0[2] := 2

Fader1[0] := 0
Fader1[1] := 0
Fader1[2] := 54

Fader2[0] := 126
Fader2[1] := 126
Fader2[2] := 106

Fader3[0] := 192
Fader3[1] := 192
Fader3[2] := 161

 REPEAT f from 0 to 3
     SetFader(F)
     DrawFader


PUB SetFader(FaderNumber)
 case FaderNumber
    0: faderval :=  Fader0[0]
       oldfader :=  Fader0[1]
       faderpos :=  Fader0[2]
       
    1: faderval :=  Fader1[0]
       oldfader :=  Fader1[1]
       faderpos :=  Fader1[2]
       
    2: faderval :=  Fader2[0]
       oldfader :=  Fader2[1]
       faderpos :=  Fader2[2]
       
    3: faderval :=  Fader3[0]
       oldfader :=  Fader3[1]
       faderpos :=  Fader3[2]
      
PUB UpdateFader 'layer 2               
  if oldfader<> faderval
    pfw.WriteActiveCr(6, faderpos, 2,  4, 0, BackgroundColor, ActiveTextColor)
    pfw.WriteActiveCr(7, faderpos, 301, 4, 0, BackgroundColor, ActiveTextColor)
  
   pfw.WriteActiveCr(32, faderpos, oldfader + 24, 4, 3, BackgroundColor, ActiveTextColor)
   pfw.WriteActiveCr(14, faderpos, faderval + 24, 4, 4, BackgroundColor, ActiveTextColor)
  
PUB DrawFader |index                'layer 1

  pfw.WriteActiveCr(1, faderpos, 0, 0, 0, BackgroundColor, ActiveTextColor)
  pfw.WriteActiveCr(9, faderpos, 7, 0, 0, BackgroundColor, ActiveTextColor)
   
     REPEAT 18
       pfw.WriteNextActiveCr(13)
    
    pfw.WriteActiveCr(1, faderpos, 297, 0, 0, BackgroundColor, ActiveTextColor)
    pfw.WriteActiveCr(9, faderpos, 304, 0, 0, BackgroundColor, ActiveTextColor)

    pfw.WriteActiveCr(6, faderpos, 2, 3, 0, BackgroundColor, ActiveTextColor)
    pfw.WriteActiveCr(7, faderpos, 301, 3, 0, BackgroundColor, ActiveTextColor)
  
    pfw.WriteActiveCr(32, faderpos, oldfader + 24, 5, 4, BackgroundColor, ActiveTextColor)
    pfw.WriteActiveCr(14, faderpos, faderval + 24, 4, 4, BackgroundColor, ActiveTextColor)


PUB FaderRun | f
  repeat
     REPEAT f from 0 to 3
       SetFader(F)
       UpdateFader
    Fader0[1] := Fader0[0]
    Fader0[0] -= 1       