CON
 ''PINS
  LCD_RS            = 16                               ''LCD RS pin
  LCD_WR            = 17                               ''LCD WR pin
   
''LCD REGISTER Enumeration, for SSM1289   
  REG_OSCILLATOR                = $0000                               ''Oscillator                                (R00h) (POR = 0000h)
  REG_DRIVEROUTPUTCONTROL       = $0001                               ''Driver Output Control                     (R01h) (POR = 2B3Fh)
  REG_LCDDRIVINGWAVFORM         = $0002                               ''LCD-Driving-Waveform Control              (R02h) (POR = 0000h)
  REG_POWERCONTROL1             = $0003                               ''                                          (R03H)
  REG_DISPLAYCONTROL            = $0007                               ''Display Control                           (R07h) (POR = 0000h)
  REG_FRAMECYCLECONTROL         = $000B                               ''Frame Cycle Control                       (R0Bh) (POR = 5308h)D308 BY DATASHEET
  REG_POWERCONTROL2             = $000C                               ''                                          (R0Ch) (POR = 0004)
  REG_POWERCONTROL3             = $000D                               ''                                          
  REG_POWERCONTROL4             = $000E                               ''
  REG_GATESCANPOSITION          = $000F                               ''Gate Scan Position                        (R0Fh) (POR = 0000h)
  REG_SLEEPMODE                 = $0010                               ''Sleep mode                                (R10h) (POR = 0001h)
  REG_ENTRYMODE                 = $0011                               ''Entry Mode                                (R11h) (POR = 6830h)             
  REG_HPORCH                    = $0016                               ''                                          (R16h) (POR = EF1Ch)
  REG_VPORCH                    = $0017                               ''                                          (R17h) (POR = 0003h)
  REG_POWERCONTROL5             = $001E                               ''                                          
  REG_RAMDATAWRITE              = $0022                               ''
  REG_RAMWRITEDATAMASK1         = $0023                               ''                                          (R23h) (POR = 0000h)
  REG_RAMWRITEDATAMASK2         = $0024                               ''                                          (R24h) (POR = 0000h)
  REG_VERTICALSCROLCONTROL1     = $0041                               ''                                          (R41h) (POR = 0000h)
  REG_VERTICALSCROLCONTROL2     = $0042                               ''                                          (R42h) (POR = 0000h)
  REG_HORIZONTALRAMADDRESSPOS   = $0044                               ''                                          (R44h) (POR = EF00h)
  REG_VERTICALRAMADDRESSSTART   = $0045                               ''                                          (R45h) (POR = 0000h)
  REG_VERTICALRAMADDRESSEND     = $0046                               ''                                          (R46h) (POR = 013Fh)
  REG_FIRSTWINDOWSTART          = $0048                               ''                                          (R48h) (POR = 0000h)
  REG_FIRSTWINDOWEND            = $0049                               ''                                          (R49h) (POR = 013Fh)
  REG_SECONDWINDOWSTART         = $004A                               ''                                          (R4Ah) (POR = 0000h)
  REG_SECONDWINDOWEND           = $004B                               ''                                          (R4Bh) (POR = 013Fh)
  REG_SETGDDRXADDRESSCOUNTER    = $004E                               ''                                          (R4Eh) (POR = 0000h)
  REG_SETGDDRYADDRESSCOUNTER    = $004F                               ''                                          (R4Fh) (POR = 0000h)

  FONT_ROM_ADDRESS              = $8000

VAR
long screenbufferaddress
long BackgroundColor,ActiveColor, ActiveTextColor, InactiveTextColor, Row, Col, RowBorder,ColBorder, WindowX1, WindowX2, WindowY1, WindowY2
 
 

obj wait : "timing"
    cr   : "crReader"
   'pst  : "parallax serial terminal"  'used for debugging..
PUB BOOT                         'not a standalone object
  

PUB Start(ScreenBufferAdd)             'Method to Init display, then load a cog with screen driver
   screenbufferaddress   := ScreenBufferAdd                'store buffer address in long
 Init_SSD1289                                                'init screen
 long[@screenbufferaddress]      := $ffff                        'make sure screen buffer does not equal 0
 result := cognew(@entry,@long[@screenbufferaddress])                          'start write driver and pass it the address of screen buffer
 cr.Start
 
PUB WriteNextActiveCr(Character) | characterpointer, odd_even, bitpatern[32], idx, pxlidx, lcdidx, pxlidxdcd, x1, y1, x2, y2, fontaddress
 fontaddress := Cr.GetChar(Character)
 'odd_even                      := character & $0001
 ' characterpointer              := character & $fffe
  'characterpointer              >>= 1
  'characterpointer              *= 32
   repeat idx from 0 to 31 
     bitpatern[idx] := word[fontaddress][idx]

  word[fontaddress] := 0

   y1 :=  Col + ColBorder  
   y2:= (Col + 15) - ColBorder 
   x1 :=  Row + RowBorder
   x2:= (Row + 31) - RowBorder
  
     SetWindow(x1, y1, x2, y2)
     SetGAddress(x1,y1)
  repeat idx from RowBorder to 31 - RowBorder        
     repeat pxlidx from ColBorder to  15 - ColBorder 
       pxlidxdcd := |< pxlidx
       if ((bitpatern[idx] & pxlidxdcd) == pxlidxdcd)  
         Lcd_Write_Asm(ActiveTextColor + (REG_RAMDATAWRITE  << 16))
       else
         Lcd_Write_Asm(BackgroundColor + (REG_RAMDATAWRITE  << 16))
     repeat while word[fontaddress] := 0


  if (((Col + 16) >  319 ) and  ((Row + 32) > 223))
    Row := 0
    Col := 0
  elseif (((Col + 16) >  319 ) and  ((Row + 32) < 223)) 
    Row := Row + 32
    Col := 0
  else
    Col := Col + 16
         
' SetWindow(0, 0, 239, 319)
PUB WriteActiveCr(Character, PosR, PosC, RBorder, CBorder, BgC, TxC) | characterpointer, odd_even, bitpatern[32], idx, pxlidx, lcdidx, pxlidxdcd, x1, y1, x2, y2, fontaddress
 fontaddress := Cr.GetChar(Character) 
   Row              := PosR      
   Col              := PosC
   RowBorder        := RBorder
   ColBorder        := CBorder
   BackgroundColor  := BgC
   ActiveTextColor  := Txc
   
    repeat idx from 0 to 31
     bitpatern[idx] := word[fontaddress][idx]
  word[fontaddress] := 0
      
   y1 :=  Col + ColBorder  
   y2:= (Col + 15) - ColBorder 
   x1 :=  Row + RowBorder   
   x2:= (Row + 31) - RowBorder 
  
     SetWindow(x1, y1, x2, y2)
     SetGAddress(x1,y1)
  repeat idx from RowBorder to 31 - RowBorder         
     repeat pxlidx from ColBorder to  15 - ColBorder 
       pxlidxdcd := |< pxlidx
       if ((bitpatern[idx] & pxlidxdcd) == pxlidxdcd)  
         Lcd_Write_Asm(ActiveTextColor + (REG_RAMDATAWRITE  << 16))
       else
         Lcd_Write_Asm(BackgroundColor + (REG_RAMDATAWRITE  << 16))
     repeat while word[fontaddress] := 0
  if (((Col + 16) >  319 ) and  ((Row + 32) > 223))
    Row := 0
    Col := 0
  elseif (((Col + 16) >  319 ) and  ((Row + 32) < 223)) 
    Row := Row + 32
    Col := 0
  else
    Col := Col + 16

PUB ClearScreen(color) | idxr, idxc
  SetWindow(0, 0, 239, 319)
  SetGAddress(0,0)
  color += (REG_RAMDATAWRITE  << 16)
  repeat idxr from 0 to 76800           
      Lcd_Write_Asm(Color)
Row              := 0      
Col              := 0
PUB SetWindow(x1, y1, x2, y2) | HORIZONTALRAMADDRESSPOS                      'Set window to draw in
 WindowX1 := x1                                                                        'update draw window in main memory
 WindowX2 := x2                                                                        'update draw window in main memory 
 WindowY1 := y1                                                                        'update draw window in main memory 
 WindowY2 := y2                                                                        'update draw window in main memory 
    HORIZONTALRAMADDRESSPOS := x1 + (x2 << 8)                                                      'combine x1 and x2 values                                                                                                  
       Lcd_Write_Asm ((REG_HORIZONTALRAMADDRESSPOS << 16) + HORIZONTALRAMADDRESSPOS)               'and write to display
       Lcd_Write_Asm(y1 + (REG_VERTICALRAMADDRESSSTART << 16))                                     'send v-address start
       Lcd_Write_Asm(y2 + (REG_VERTICALRAMADDRESSEND << 16))                                       'send v-address end
       
PUB SetGAddress(x,y)                                                         'Set address for gddr writes
       Lcd_Write_Asm ((REG_SETGDDRXADDRESSCOUNTER << 16) + x)      ''max %1111_1111, $FF
       Lcd_Write_Asm ((REG_SETGDDRYADDRESSCOUNTER << 16) + y)      ''max %1_0011_1111, $13f

PRI deadend                                                               'loop for testing
 repeat
  repeat                                                                             'endlessly wait
    wait.pause1s(1)                                                                            ''                                                                    
PRI EnableDisplayPins                                                    'enable all pins -
    DIRA:=%00000000_00000000_11111111_11111111        ''enable p15 - p0    
PRI TristateDisplayPins                                                  'tristate all pins -                                                 
    DIRA:=%00000000_00000000_00000000_00000000        ''release p15 - p0

PRI Lcd_Write_Asm(V)                                   'handler for asm writes
     repeat while (long[@screenbufferaddress] <> 0)                        'waits for cog to clear screenbuffer
  long[@screenbufferaddress] := V                                        'makes screen buffer = v
                       
PRI LCD_Writ_Bus(V)                   'write to display
    OUTA[15..0]  := V                       ' copy V onto pins
    WriteLow                                ' write pin low
    WriteHigh                               ' toggle write pin

PRI Lcd_Write_Com(V)                    'write command to display
    LCD_RSLow                               'Sets command
    LCD_Writ_Bus(V)                         'Do write

PRI LCD_Write_Data(V)                   'write data to display
    LCD_RSHigh                              'Sets data
    LCD_Writ_Bus(V)                         'do write

PRI LCD_RSLow
    outa[LCD_RS] := 0                             'controls RS pin with DIR-A         
    dira[LCD_RS] := 1                       'see hardware revision

PRI LCD_RSHigh                              'controls RS pin with DIR-A
    dira[LCD_RS] := 0                       'see hardware revision   

PRI WriteLow
    outa[LCD_WR] := 0                          'controls WR pin with DIR-A        
    dira[LCD_WR] := 1                        'see hardware revision      ' 

PRI WriteHigh                           'controls WR pin with DIR-A 
    dira[LCD_WR] := 0                        'see hardware revision 

PRI Init_SSD1289                ''Init Display


 EnableDisplayPins

   outa[21] := 1
   dira[21] := 1
    Lcd_Write_Com (REG_DISPLAYCONTROL)                  ''Display Control (R07h) (POR = 0000h) 
    Lcd_Write_Data($0021)                               ''GON = 1 DTE = 0 D[1:0] = 01
    
    Lcd_Write_Com (REG_OSCILLATOR)                      ''Oscillator (R00h) (POR = 0000h)
    Lcd_Write_Data($0001)                               ''Turn on oscillator
    
    Lcd_Write_Com (REG_DISPLAYCONTROL)                  ''Display Control (R07h) (POR = 0000h)
    Lcd_Write_Data($0023)                               ''GON = 1 DTE = 0 D[1:0] = 11
            
    Lcd_Write_Com (REG_SLEEPMODE)                       ''Sleep mode (R10h) (POR = 0001h)
    Lcd_Write_Data($0000)     ''                        ''exit sleep mode
    
    Lcd_Write_Com (REG_DISPLAYCONTROL)                  ''Display Control (R07h) (POR = 0000h)
    Lcd_Write_Data($0033)                               ''GON = 1 DTE = 1 D[1:0] = 11
    
    Lcd_Write_Com (REG_ENTRYMODE)                       ''Entry Mode (R11h) (POR = 6830h)
    Lcd_Write_Data($6838)                               ''
    
    Lcd_Write_Com (REG_LCDDRIVINGWAVFORM)               ''LCD-Driving-Waveform Control (R02h) (POR = 0000h)($1000) 
    Lcd_Write_Data($1000)     ''                        ''
    
    Lcd_Write_Com (REG_GATESCANPOSITION)                ''Gate Scan Position (R0Fh) (POR = 0000h)  ($0000)
    Lcd_Write_Data($0000)     ''                        ''
                                        ''
    Lcd_Write_Com (REG_DRIVEROUTPUTCONTROL)             ''Driver Output Control (R01h) (POR = [0XXXX0X1]3Fh) 433f    ($633F) 
    Lcd_Write_Data($6B3F) ''                            ''
                                    
    Lcd_Write_Com (REG_FRAMECYCLECONTROL)               ''Frame Cycle Control (R0Bh) (POR = 5308h) ($5308)
    Lcd_Write_Data($5308)                               ''
            '
    Lcd_Write_Com (REG_DISPLAYCONTROL)                  ''Display Control (R07h) (POR = 0000h) ($0033)
    Lcd_Write_Data($0033)
    TristateDisplayPins                            ''Release pins

'PUB PST_Init  | PstCog                                       ''Starts Parallax Serial Terminal for debugging.
'  PstCog := (pst.Start(115200) -1)                             '' returns the cog pst started in
'  pst.Str(String("Parallax Serial Terminal started in cog "))  ''  talk to human
'  pst.Dec(PstCog)                                              '' displays cog on PST                                                  ''
'  wait.pause1s(1)
PUB HelloWorld
    WriteActiveCr("H", 0, 0*16, 0, 0, $ffff, $0000)    
    WriteNextActiveCr("e")
    WriteNextActiveCr("l")
    WriteNextActiveCr("l")
    WriteNextActiveCr("o")
    WriteNextActiveCr(" ")
    WriteNextActiveCr("W")
    WriteNextActiveCr("o")
    WriteNextActiveCr("r")
    WriteNextActiveCr("l")
    WriteNextActiveCr("d")
DAT                                             'init  Display driver
                                                'designed for optimized hardware, pull-up resistors on RS and WR pins.
               org 0                             
entry             mov outa, PinsInit             'set pins to inital state
                mov dira, DirsEnabled            'enables p0 - p15        
                  mov bufferaddress, par                      'store par in bufferaddress, par is screen buffer address at startup 
                 'mov dira, DirsDisabled                    'disables p0 - p15 if necessary    
                 wrlong zero, bufferaddress                   'set par to zero to confirm load done
                                               'get write command from buffer, and check if it's 0
                                                                                           
Get                      rdlong LCD_Data, bufferaddress           'get long from main memory and put it in ldc command, msW = LCD cmd, LSw = LCD data
                         cmp    Lcd_Data, #0                wz    'and check if it's 0
if_z                     jmp #get                                 'if it is, try again.
                                               'if not, prepare transfer
                         'mov dira, DirsEnabled                          'set pins if necessary                        
                         mov LCD_cmd, LCD_Data                    'copy lcd command to lcd data
                         
                         shr LCD_cmd, #16                         'move lcd command 16 bit to the right if not gddr write
'                        cmp LCD_cmd, #22                   wz    'check to see if this is a gddr write  
'if_nz                   jmp WRcmd         
                                        'optimized write to display, for gddr transfer
                                        
                                              'enables p0 - p15 
                         mov    pntr, #$8                          'set wait period
:wait0                   djnz   pntr, :wait0                       'and wait

WrCmd                    mov    outa, LCD_Cmd                  'place LCD_Cmd on write bus

                         mov    pntr, #$8                           'set wait period
:wait0                   djnz   pntr, :wait0                        'and wait

                         add    zero, #0               wz   'prime WZ flag                       
                         muxz   dira, RSpin                    'make RS pin low by enabling its DIR REG
                         
                         mov    pntr, #$8                           'set wait period
:wait1                   djnz   pntr, :wait1                        'and wait
 
                         muxz   dira, WritePin                 'make Write Pin low by enabling its DIR REG

                         and LCD_Data, lowWordMask                'mask off High word of Lcd_Data
                         
                         mov    pntr, #$f                           'set wait period
:wait2                   djnz   pntr, :wait2                        'and wait
              
                         muxnz  dira, WritePin                 'make Write Pin high by disabling its DIR REG
                         
                         mov    pntr, #$8                           'set wait period
:wait3                   djnz   pntr, :wait3                        'and wait

                         muxnz  dira, RSpin                    'make RS pin high by disabling its DIR REG
                        
                         mov    pntr, #$8                          'set wait period
:wait4                   djnz   pntr, :wait4                        'and wait

:WrDataPortion                                                 
                         mov    outa, LCD_Data                 'place LCD_Data on write bus
                         wrlong zero, bufferaddress     'wz
                         mov    pntr, #$8                           'set wait period  
:wait5                   djnz   pntr, :wait5                        'and wait

                         add    zero, #0               wz    'prime WZ flag
                         muxz   dira, WritePin                  'make Write Pin low by enabling its DIR REG
                        
                          
                          'rdlong LCD_Data, bufferaddress           'get long from main memory and put it in ldc command, msW = LCD cmd, LSw = LCD data 

                         mov    pntr, #$8                          'set wait period
:wait6                   djnz   pntr, :wait6                        'and wait

                         muxnz  dira, WritePin                  'make Write Pin high by disabling its DIR REG
                         
                         mov    pntr, #$8                           'set wait period
:wait7                   djnz   pntr, :wait7                        'and wait
                         'mov    dira, DirsDisabled                 'disables p0 - p15
                                               
                  jmp #Get                              'do it all again



                  

zero                              long $0
lowWordMask                       long $0000_ffff
                                      'pin settings
WritePin                          long   %00000000_00000010_00000000_00000000
RSPin                             long   %00000000_00000001_00000000_00000000                                          
PinsInit                          long   %00000000_00000000_00000000_00000000
DirsDisabled                      long   %00000000_00000000_00000000_00000000
DirsEnabled                       long   %00000000_00000000_11111111_11111111                                                                           ''                                          (R4Fh) (POR = 0000h)




bufferaddress           res 1
LCD_cmd                 res 1
LCD_data                res 1
Pntr                    res 1

ForegroundFormat        res 1
BackgroundFormat        res 1
ForegroundScreen        res 1
BackgroundScreen        res 1
fit                  